/*
 * Created on 25.01.2005
 * 
 * To change the template for this generated file go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */
package sos.stresstest.dialogtest;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import sos.util.SOSClassUtil;
import sos.util.SOSLogger;
//import sos.util.SOSStandardLogger;

/**
 * @author ur
 * Ein Take aus einem Recording. Liest alle Checkpoints und fhrt sie aus.
 *  
 */
public class DialogTake extends DialogTesterBasic {

    private String name = "";
    private boolean success;
    //private ArrayList listOfCheckpoints; // Enthlt die Checkpoints des Takes
    private Node node;
    private NodeList nodesCheckpoints = null;
    private DialogTester caller = null;

    /**
     * @param sosLogger_
     * @param name
     */
    protected DialogTake(SOSLogger sosLogger_, String name) {
        this.name = name;
        success = true;
        this.sosLogger = sosLogger_;
    }

	// Fhrt einen Take aus. Ein Take besteht aus n Checkpoints.
	protected boolean execute() throws Exception {
		
		DialogCheckpoint checkpoint = null;
		DialogTesterTags tag;
		int cnt = 0;
		
		try {
			
			nodesCheckpoints = node.getChildNodes();
			
			for (int i = 0; i < nodesCheckpoints.getLength(); i++) {
				
				if (nodesCheckpoints.item(i).getAttributes() != null)
					cnt++;
			}
			
			if (cnt == 1)
				log_info("   -> Starting Take '" + name + "' with one Checkpoint");
			else
				log_info("   -> Starting Take '" + name + "' with " + cnt + " Checkpoints");
			
			
			for (int i = 0; i < nodesCheckpoints.getLength(); i++) {
				
				if (nodesCheckpoints.item(i).getAttributes() != null) {
					
					checkpoint = new DialogCheckpoint(sosLogger, nodesCheckpoints.item(i).getAttributes().getNamedItem("name").getNodeValue());
					checkpoint.setNode(nodesCheckpoints.item(i));
					checkpoint.setCaller(caller);
					checkpoint.setTake(name);
					
					log_debug4("Tag-Replacement Start:");
					for (int j = 0; j < caller.getTagValues().size(); j++) {
						
						tag = (DialogTesterTags) caller.getTagValues().get(j);
						log_debug4("Take des Tags=aktTake? --> "  + tag.getTake() + "=" + name);
						// Alle Replacements dieses Takes. Prfen ob aktiv
						
						if (tag.getTake().equals(name)) {
							log_debug4("StartCheckPoint=aktCheckpoint? --> "  + tag.getStartDialogCheckpoint() + "=" + checkpoint.getName());
							tag.setActive(tag.getStartDialogCheckpoint().equals(checkpoint.getName()));
							//System.out.println(i+") "+tag.getTake()+"->DialogTake.StartDialogCheckpoint: "+tag.getStartDialogCheckpoint());
						}
					}
					
					success = ( success && checkpoint.execute() );
					
					log_debug4("Tag-Replacement Stop:");
					for (int j = 0; j < caller.getTagValues().size(); j++) {
						
						tag = (DialogTesterTags) caller.getTagValues().get(j);
						log_debug4("Take des Tags=aktTake? --> "  + tag.getTake() + "=" + name);
						// Alle Replacements dieses Takes. Prfen ob weiterhin aktiv
						
						if (tag.getTake().equals(name)) {
							log_debug4("StartCheckPoint<>aktCheckpoint? --> "  + tag.getStartDialogCheckpoint() + "<>" + checkpoint.getName());
							tag.setActive( !tag.getEndDialogCheckpoint().equals(checkpoint.getName()) );
							//System.out.println(i+") "+tag.getTake()+"->DialogTake.EndDialogCheckpoint: "+tag.getEndDialogCheckpoint());
						}
					}
				}
			}
			
		} catch (Exception e) {
			String err_msg = "";
			if (this.getDebugLevel()>2)
				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
  		throw new Exception(err_msg + e.getMessage());
		}
		
		return success;
	}
	
    /**
     * @param node
     *            The node to set.
     */
    protected void setNode(Node node) {
        this.node = node;
    }

    /**
     * @param caller
     *            The caller to set.
     */
    protected void setCaller(DialogTester caller) {
        this.caller = caller;
    }

    /**
     * @return Returns the name.
     */
    protected String getName() {
        return name;
    }

}