/*
 * Created on 10.12.2004
 * 
 * To change the template for this generated file go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */
package sos.stresstest.dialogtest;

import sos.connection.SOSConnection;
import sos.util.SOSLogger;
import sos.util.SOSStandardLogger;

 
/**
 * Stellt einen Logger und eine Connection zur Verfgung. 
 * Stellt Methoden fr das Logging zur Verfgung. Mit diesen Methoden brauchen Logging-Aufrufe nicht in einem
 * zu stehen.
 * 
 * @author ur
 * 
 */
public class DialogTesterBasic {

    //protected SOSStandardLogger sosLogger = null;
    protected SOSLogger sosLogger = null;
    protected SOSConnection conn = null;
    private int debugLevel = 0;
    private String logFile = "";
		
    public DialogTesterBasic() {

    }

    /**
     * Erzeugt einen Logger und eine Connection
     * 
     *  <pre>x.init("c:/temp/inifile.ini");</pre>
     * 
     * @param iniSOSFile Name der Datei mit den Verbindungsparameter
     * 
     * <pre>
     * # JDBC-relevante Eigenschaften

     * class=SOSOracleConnection
     * datasource=DBI:Oracle:dod
     * driver=oracle.jdbc.driver.OracleDriver
     * url=jdbc:oracle:thin:@x.sos:1521:test
     * user=xxx
     * password=yyy
     *</pre>
     * @throws Exception
     */
	protected void init(String iniSOSFile) throws Exception {
		
		try {
			
			if ( sosLogger==null ) {
				
				if ( !logFile.equals("") )
					sosLogger = (SOSLogger)new SOSStandardLogger(logFile, debugLevel);
				//else	sosLogger = (SOSLogger)new SOSStandardLogger(debugLevel);
				
				this.log_debug4("DialogTesterBasic.init: create new logger");
			} else {
				this.log_debug4("DialogTesterBasic.init: use existing logger");
			}
			
		} catch (Exception e) {
			throw new Exception("cannot initialize logger: "+e.getMessage());
		}
		
		if ( !iniSOSFile.equals("") ) {
			
			try {
				conn = SOSConnection.createInstance(iniSOSFile, sosLogger);
				conn.setFieldNameToUpperCase(false);
				conn.setTableNameToUpperCase(false);
				conn.connect();
				conn.setAutoCommit(false);
				this.log_debug4("DialogTesterBasic.init: neue Connection wurde erzeugt");
			} catch (Exception e) {
				throw new Exception(e);
			}
		}
	}
	
	protected void init() throws Exception {
		
		init("");
	}
	
	/**
	 * log-Ausgabe fr catch-Blcke, wenn eine Exception aufgetreten ist.
	 * Diese Ausgabe fngt Exceptions IN der log-Ausgabe ab, damit der eigentliche Fehler gemeldet wird.
	 * @param s Ausgabestring
	 */
	protected void catch_log(String s) {
		
		try {
			this.log_warn(s);
		} catch (Exception e) { }
	}

	
/*
     * Ruft die Methode .error des Logging-Objektes auf. Wenn eine Exception geworfen wird, 
     * wird der Text + eine Fehlermeldung nach StdOut geschrieben.
     *
     * @param s Der zu protokolierende Text
     *
    public void log_error(String s) throws Exception {
    	if (sosLogger != null)
        try {
					sosLogger.error(s);
        } catch (Exception e) {
					throw new Exception(s + " - error in DialogTesterBasic.log_error(): " + e.getMessage());
        }
    }
*/
	
    /**
     * Ruft die Methode .info des Logging-Objektes auf. Wenn eine Exception geworfen wird, 
     * wird der Text + eine Fehlermeldung nach StdOut geschrieben.
     *
     * @param s Der zu protokolierende Text
     */
    public void log_info(String s) throws Exception {
			if (sosLogger != null)
				try {
					sosLogger.info(s);
				} catch (Exception e) {
					throw new Exception(s + " - error in DialogTesterBasic.log_info(): " + e.getMessage());
        }
    }

    /**
     * Ruft die Methode .warn des Logging-Objektes auf. Wenn eine Exception geworfen wird, 
     * wird der Text + eine Fehlermeldung nach StdOut geschrieben.
     *
     * @param s Der zu protokolierende Text
     */
		public void log_warn(String s) throws Exception {
			if (sosLogger != null)
        try {
					sosLogger.warn(s);
        } catch (Exception e) {
					throw new Exception(s + " - error in DialogTesterBasic.log_warn(): " + e.getMessage());
        }
    }

    /**
     * Ruft die Methode .debug3 des Logging-Objektes auf. Wenn eine Exception geworfen wird, 
     * wird der Text + eine Fehlermeldung nach StdOut geschrieben.
     *
     * @param s Der zu protokolierende Text
     */
		public void log_debug3(String s) throws Exception {
			if (sosLogger != null)
        try {
					sosLogger.debug3(s);
        } catch (Exception e) {
        	throw new Exception(s + " - error in DialogTesterBasic.log_debug3(): " + e.getMessage());
        }
    }

     /**
     * Ruft die Methode .debug4 des Logging-Objektes auf. Wenn eine Exception geworfen wird, 
     * wird der Text + eine Fehlermeldung nach StdOut geschrieben.
     *
     * @param s Der zu protokolierende Text
     */
    public void log_debug4(String s) throws Exception {
    	if (sosLogger != null)
        try {
					sosLogger.debug4(s);
        } catch (Exception e) {
        	throw new Exception(s + " - error in DialogTesterBasic.log_debug4(): " + e.getMessage());
        }
    }

     /**
     * Ruft die Methode .debug5 des Logging-Objektes auf. Wenn eine Exception geworfen wird, 
     * wird der Text + eine Fehlermeldung nach StdOut geschrieben.
     *
     * @param s Der zu protokolierende Text
     */
    public void log_debug5(String s) throws Exception {
    	if (sosLogger != null)
        try {
					sosLogger.debug5(s);
        } catch (Exception e) {
        	throw new Exception(s + " - error in DialogTesterBasic.log_debug5(): " + e.getMessage());
        }
    }

/*
     * Ruft die Methode .debug6 des Logging-Objektes auf. Wenn eine Exception geworfen wird, 
     * wird der Text + eine Fehlermeldung nach StdOut geschrieben.
     *
     * @param s Der zu protokolierende Text
     *
    public void log_debug4(String s) throws Exception {
    	if (sosLogger != null)
        try {
					sosLogger.debug6(s);
        } catch (Exception e) {
        	throw new Exception(s + " - error in DialogTesterBasic.log_debug4(): " + e.getMessage());
        }
    }

     /**
     * Ruft die Methode .debug7 des Logging-Objektes auf. Wenn eine Exception geworfen wird, 
     * wird der Text + eine Fehlermeldung nach StdOut geschrieben.
     *
     * @param s Der zu protokolierende Text
     *
    public void log_debug7(String s) throws Exception {
    	if (sosLogger != null)
        try {
					sosLogger.debug7(s);
        } catch (Exception e) {
        	throw new Exception(s + " - error in DialogTesterBasic.log_debug7(): " + e.getMessage());
        }
    }

     /**
     * Ruft die Methode .debug8 des Logging-Objektes auf. Wenn eine Exception geworfen wird, 
     * wird der Text + eine Fehlermeldung nach StdOut geschrieben.
     *
     * @param s Der zu protokolierende Text
     *
    public void log_debug8(String s) throws Exception {
    	if (sosLogger != null)
        try {
					sosLogger.debug8(s);
        } catch (Exception e) {
					throw new Exception(s + " - error in DialogTesterBasic.log_debug8(): " + e.getMessage());
        }
    }

     /**
     * Ruft die Methode .debug9 des Logging-Objektes auf. Wenn eine Exception geworfen wird, 
     * wird der Text + eine Fehlermeldung nach StdOut geschrieben.
     *
     * @param s Der zu protokolierende Text
     *
    public void log_debug5(String s) throws Exception {
    	if (sosLogger != null)
        try {
					sosLogger.debug9(s);
        } catch (Exception e) {
					throw new Exception(s + " - error in DialogTesterBasic.log_debug5(): " + e.getMessage());
        }
    }
*/


    /**
     * @param debugLevel
     *            The debugLevel to set.
     */
    public void setDebugLevel(int debugLevel) {
        this.debugLevel = debugLevel;
    }
		
    /**
     * @return Returns the debugLevel.
     */
    protected int getDebugLevel() {
        return debugLevel;
    }
    /**
     * @param sosLogger
     *            The sosLogger to set.
     */
    /**
     * @return Returns the logFile.
     */
    public String getLogFile() {
        return logFile;
    }
    /**
     * @param logFile The logFile to set.
     */
    public void setLogFile(String logFile) {
        this.logFile = logFile;
    }
		
    /**
     * @param sosLogger The sosLogger to set.
     */
    public void setSosLogger(SOSLogger sosLogger) {
				this.sosLogger = sosLogger;
    }
    
    public SOSLogger getSosLogger() {
			return sosLogger;
		}
    
    /**
     * @return Returns the conn.
     */
    public SOSConnection getConn() {
        return conn;
    }
}