// $Id: xml.h 4915 2007-03-25 11:42:04Z jz $

#ifndef __ZSCHIMMER_XML_H
#define __ZSCHIMMER_XML_H

#include "z_io.h"


#define DOM_FOR_EACH_ELEMENT( PARENT, ITERATOR )                                                \
                                                                                                \
    for( ::zschimmer::xml::libxml2::Simple_node_ptr ITERATOR##_node = (PARENT).firstChild();    \
         ITERATOR##_node;                                                                       \
         ITERATOR##_node = ITERATOR##_node.nextSibling() )                                      \
                                                                                                \
    if( ::zschimmer::xml::libxml2::Element_ptr ITERATOR = xml::Element_ptr( ITERATOR##_node, ::zschimmer::xml::libxml2::Element_ptr::no_xc ) )


namespace zschimmer {
namespace xml {

//-------------------------------------------------------------------------------------------------

string                          encode_text                 ( const string&, bool quote_too = false );
inline string                   encode_attribute_value      ( const string& value )             { return encode_text( value, true ); }

//---------------------------------------------------------------------------------------Xml_writer

struct Xml_writer : io::Filter_writer
{
                                Xml_writer                  ( Writer* );

    void                        begin_element               ( const string& element_name );
    void                        set_attribute               ( const string& name, const string& );
    void                        set_attribute               ( const string& name, int64 );
    void                        set_attribute_optional      ( const string& name, const string& );
    void                        end_element                 ( const string& element_name );

    void                        write                       ( const io::Char_sequence& utf8_text );
    void                        write_through               ( const io::Char_sequence& text );
    void                        flush                       ();

  protected:
    void                        close_tag                   ();

  private:
    bool                       _is_tag_open;
};

//-------------------------------------------------------------------------------------------------

} //namespace xml
} //namespace zschimmer

#endif
